
// released to public domain 08/09/96 by author, Phil Barnett

FUNCTION FILETRAN( IN_FILE, OUT_FILE, LOOKFOR, REPWITH )

local buffer
local bytesread

/*

You can change the buffer size but too large will begin slowing it down.
Play with it to find optimum, but remember, the actual performance is
pretty much hardware related. In other words, optimum size on a hard
disk may be very different that optimum size on a network, or even
another hard drive. I find that multiples of 2048 are best (cluster
sizes) On the other hand, it begins to need more and more working memory
as you increase the buffer size. certainly there will be a tradeoff
between usability and speed.

*/

local size := 4096

local HANDLE_IN
local DATA_IN := ''
local looklen := len( LOOKFOR ) - 1 // very important

local HANDLE_OUT
local DATA_OUT

HANDLE_IN := fopen( IN_FILE, 66 )   // open for shared read/write
IF HANDLE_IN == -1
   fclose( HANDLE_IN )
   ? 'Error opening Input file.'
   RETURN .f.
ENDIF

HANDLE_OUT := fCREATE( OUT_FILE, 0 )
IF HANDLE_OUT == -1
   fclose( HANDLE_OUT )
   ? 'Error creating Output file.'
   RETURN .f.
ENDIF

bytesread := size
buffer := SPACE( size )

DO WHILE bytesread == size

   bytesread := fread( HANDLE_IN, @buffer, size )

   DATA_IN += LEFT( buffer, bytesread )
   data_out := strtran( data_in, lookfor, repwith )

   if bytesread == size // there's more, keep looklen bytes for next loop
      data_in := right( data_out, looklen )
      data_out := left( data_out, LEN( data_out ) - looklen )
   endif

   fwrite( handle_out, data_out )

ENDDO

fclose( HANDLE_IN )
fclose( HANDLE_OUT )

RETURN .t.
